diff --git a/libio/iopopen.c b/libio/iopopen.c
index 22d53a88ef..a15d3bf4b6 100644
--- a/libio/iopopen.c
+++ b/libio/iopopen.c
@@ -281,7 +281,11 @@ _IO_new_proc_close (FILE *fp)
      described in POSIX.2, such implementations are not conforming." */
   do
     {
-      wait_pid = __waitpid_nocancel (((_IO_proc_file *) fp)->pid, &wstatus, 0);
+      int state;
+      __libc_ptf_call (__pthread_setcancelstate,
+		       (PTHREAD_CANCEL_DISABLE, &state), 0);
+      wait_pid = __waitpid (((_IO_proc_file *) fp)->pid, &wstatus, 0);
+      __libc_ptf_call (__pthread_setcancelstate, (state, NULL), 0);
     }
   while (wait_pid == -1 && errno == EINTR);
   if (wait_pid == -1)
diff --git a/sysdeps/generic/not-cancel.h b/sysdeps/generic/not-cancel.h
index d3b53e48cf..e0729bb1db 100644
--- a/sysdeps/generic/not-cancel.h
+++ b/sysdeps/generic/not-cancel.h
@@ -47,8 +47,6 @@
   __write (fd, buf, n)
 #define __writev_nocancel_nostatus(fd, iov, n) \
   (void) __writev (fd, iov, n)
-# define __waitpid_nocancel(pid, stat_loc, options) \
-  __waitpid (pid, stat_loc, options)
 #define __fcntl64_nocancel(fd, cmd, ...) \
   __fcntl64 (fd, cmd, __VA_ARGS__)
 
diff --git a/sysdeps/posix/system.c b/sysdeps/posix/system.c
index d8c6cb8e1c..6de85bd3e4 100644
--- a/sysdeps/posix/system.c
+++ b/sysdeps/posix/system.c
@@ -81,7 +81,11 @@ cancel_handler (void *arg)
 
   __kill_noerrno (args->pid, SIGKILL);
 
-  TEMP_FAILURE_RETRY (__waitpid_nocancel (args->pid, NULL, 0));
+  int state;
+  __libc_ptf_call (__pthread_setcancelstate,
+                   (PTHREAD_CANCEL_DISABLE, &state), 0);
+  TEMP_FAILURE_RETRY (__waitpid (args->pid, NULL, 0));
+  __libc_ptf_call (__pthread_setcancelstate, (state, NULL), 0);
 
   DO_LOCK ();
   if (SUB_REF () == 0)
diff --git a/sysdeps/unix/sysv/linux/Makefile b/sysdeps/unix/sysv/linux/Makefile
index 07776d28ea..8735092c12 100644
--- a/sysdeps/unix/sysv/linux/Makefile
+++ b/sysdeps/unix/sysv/linux/Makefile
@@ -216,7 +216,7 @@ sysdep_routines += xstatconv internal_statvfs internal_statvfs64 \
 		   open_nocancel open64_nocancel \
 		   openat_nocancel openat64_nocancel \
 		   read_nocancel pread64_nocancel \
-		   waitpid_nocancel write_nocancel statx_cp
+		   write_nocancel statx_cp
 
 sysdep_headers += bits/fcntl-linux.h
 
diff --git a/sysdeps/unix/sysv/linux/not-cancel.h b/sysdeps/unix/sysv/linux/not-cancel.h
index 192a0a5195..49e4e0249a 100644
--- a/sysdeps/unix/sysv/linux/not-cancel.h
+++ b/sysdeps/unix/sysv/linux/not-cancel.h
@@ -69,9 +69,6 @@ __writev_nocancel_nostatus (int fd, const struct iovec *iov, int iovcnt)
   INTERNAL_SYSCALL_CALL (writev, err, fd, iov, iovcnt);
 }
 
-/* Uncancelable waitpid.  */
-__typeof (waitpid) __waitpid_nocancel;
-
 /* Uncancelable fcntl.  */
 __typeof (__fcntl) __fcntl64_nocancel;
 
@@ -84,7 +81,6 @@ hidden_proto (__read_nocancel)
 hidden_proto (__pread64_nocancel)
 hidden_proto (__write_nocancel)
 hidden_proto (__close_nocancel)
-hidden_proto (__waitpid_nocancel)
 hidden_proto (__fcntl64_nocancel)
 #endif
 
diff --git a/sysdeps/unix/sysv/linux/waitpid_nocancel.c b/sysdeps/unix/sysv/linux/waitpid_nocancel.c
deleted file mode 100644
index 3697c6b938..0000000000
--- a/sysdeps/unix/sysv/linux/waitpid_nocancel.c
+++ /dev/null
@@ -1,34 +0,0 @@
-/* Linux waitpid syscall implementation -- non-cancellable.
-   Copyright (C) 2018-2019 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <https://www.gnu.org/licenses/>.  */
-
-#include <errno.h>
-#include <sysdep-cancel.h>
-#include <stdlib.h>
-#include <sys/wait.h>
-#include <not-cancel.h>
-
-__pid_t
-__waitpid_nocancel (__pid_t pid, int *stat_loc, int options)
-{
-#ifdef __NR_waitpid
-  return INLINE_SYSCALL_CALL (waitpid, pid, stat_loc, options);
-#else
-  return INLINE_SYSCALL_CALL (wait4, pid, stat_loc, options, NULL);
-#endif
-}
-libc_hidden_def (__waitpid_nocancel)